// empty-clip
// © jonas.sundstrom@kirilla.com

#define DEBUG 0
#include <Debug.h>

#include <stdio.h>
#include <stdlib.h>

#include <Application.h>
#include <Roster.h>
#include <String.h>
#include <File.h>
#include <Clipboard.h>
#include <FindDirectory.h>
#include <Path.h>
#include <string.h>

#include "empty-clip-app.h"

int	exitvalue;

int main()
{
	exitvalue = EXIT_SUCCESS;

	new ClipApp();
	be_app	-> Run();
	delete	be_app;

	return (exitvalue);
}

ClipApp::ClipApp	(void)
 : BApplication	("application/x-vnd.Kirilla-empty-clip")
{
	got_arguments	=	false;	
}

ClipApp::~ClipApp	(void)
{

}

void 
ClipApp::ArgvReceived	(int32 argc, char **argv)
{
	got_arguments	=	true;

	BString argument = argv[1];
	
	if (argument == "--help")
	{
		Help();
		return;
	}
}

void
ClipApp::ReadyToRun	(void)
{
	if (! got_arguments)
		Empty();
		
	be_app->PostMessage(B_QUIT_REQUESTED);
}


void
ClipApp::Help	(void)
{
	printf(	"empty-clip 1.0 (c) jonas.sundstrom@kirilla.com\n\n"

			"Syntax:  empty-clip [--help]\n\n"
			
			"Options:\n"
			"--help          Display this marvelous help text.\n\n");
}

void
ClipApp::Empty	()
{
	status_t	status	=	B_OK;
	
	// empty clipboard

	if (be_clipboard->Lock())
	{
		be_clipboard->Clear();
		status = be_clipboard->Commit();
		
		if (status != B_OK)
		{
			be_clipboard->Unlock();
			exitvalue = EXIT_FAILURE;
			return;
		}
	
		be_clipboard->Unlock();
	}
	else
	{
		printf("load-clip failed. Could not lock clipboard.\n");
		exitvalue = EXIT_FAILURE;
		return;
	}

	printf("Clip emptied.\n");
}
